#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;

const int N = 1e5;

vector<int> f(N + 1);

void precalc() {
    f[0] = 1;
    for (int i = 1; i <= N; i++) {
        f[i] = f[i - 1] * i % mod;
    }
}

int binpow(int a, int n) {
    if (n == 1) {
        return a;
    }
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int res = binpow(a, n / 2);
        return res * res % mod;
    }
    return a * binpow(a, n - 1) % mod;
}

int cnk(int n, int k) {
    return (f[n] * binpow(f[n - k], mod - 2) % mod) * binpow(f[k], mod - 2) % mod;
}

void solve() {
    precalc();
    int n, k;
    cin >> n >> k;
    vector<int> vec(n);
    for (auto &i : vec) {
        cin >> i;
    }
    vector<vector<vector<int>>> dp(n, vector<vector<int>> (k + 1, vector<int> (k + 1, 0)));
    for (int i = 0; i < n; i++) {
        dp[i][0][0] = 1;
        for (int mask = 0; mask < (1 << k); mask++) {
            int cur = 0;
            if (__builtin_popcount(mask) > vec[i]) continue;
            for (int j = 0; j < k; j++) {
                dp[i][j + 1][0] += 1;
                if (mask & (1 << j)) {
                    cur++;
                }
                if (!i) {
                    dp[i][j + 1][cur] += 1;
                } else {
                    dp[i][j + 1][cur] += dp[i - 1][j][vec[i] - cur];
                }
                dp[i][j + 1][cur] %= mod;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= k; j++) {
            for (int v = 0; v <= k; v++) {
                cout << i << ' ' << j << ' ' << v << ':' << endl << dp[i][j][v] << '\n';
            }
        }
    }
    cout << dp[n - 1][k][vec[n - 1]] << endl;
}

signed main()
{
    // ios_base::sync_with_stdio(false);
    // cin.tie(nullptr);
    int z = 1;
    //    cin >> z;
    while (z--) {
        solve();
    }
}
